PROGRAM_NAME='ESCIENT, TUNEBASE (JOYSTICK), RS-232, BASIC, 11-98, RDW'
(*   DATE:05/20/99    TIME:17:36:49    *)
(***********************************************************)
(* The following code block is provided as a guide to      *)
(* programming the device(s) listed above. This is a       *)
(* sample only, and will most likely require modification  *)
(* to be integrated into a master program.                 *)
(*                                                         *)
(* Device-specific protocols should be obtained directly   *)
(* from the equipment manufacturer to ensure compliance    *)
(* with the most current versions. Within the limits       *)
(* imposed by any non-disclosure agreements, AMX will      *)
(* provide protocols upon request.                         *)
(*                                                         *)
(* If further programming assistance is required, please   *)
(* contact your AMX customer support team.                 *)
(*                                                         *)
(***********************************************************)
(* GENERAL FUNCTION LIST -                                 *)
(*   1.) USES A VGA AND A JOYSTICK TO MAKE THE TOUCH PANEL *)
(*       ACT AS A VIDEO TOUCH MONITOR FOR THE TUNEBASE.    *)
(*   2.) MOMENTARY FUNCTIONS ARE NOT POSSIBLE AS PROTOCOL  *)
(*       IS A PUSH-RELEASE COMMAND.  THE PROTCOL DOES NOT  *)
(*       ALLOW FOR SEPERATE PUSH AND RELEASE MOUSE COMMANDS*)
(*   3.) THIS CAN ALSO WORK WITH COMPOSITE VIDEO BUT DUE TO*)
(*       IMAGE QUUALITY, VGA IS RECOMMENDED.               *)
(*   4.) SOME WINDOWS BUTTONS CANNOT BE PRESSED, SUCH AS   *)
(*       THE PRINT DIALOG BUTTONS SINCE ESCIENT TUNEBASE   *)
(*       DOES NOT POST THE MOUSE MESSAGES GLOBALLY TO      *)
(*       WINDOWS.  THIS CANNOT BE FIXED BY AMX AND IS A    *)
(*       LIMITATION IMPOSED BY THE TUNEBASE SOFTWARE.      *)
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

TUNEBASE      = 1                  (* AXC-232: ESCIENT TUNEBASE 9600 8N1 *)
TP            = 128                (* AXT-CG10 PANEL *)

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT

(* TUNEBASE *)
TB_JOYSTICK      = 255             (* FUNCTION FOR JOYSTICK PUSH *)

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

(* JOYSTICK *)
TP_JOYST_1X                        (* LEVELS FOR OUR JOYSTICKS *)
TP_JOYST_1Y

(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE

(***********************************************************)
(*           SUBROUTINE DEFINITIONS GO BELOW               *)
(***********************************************************)

(**************************************)
(* CALL NAME: TUNEBASE FUNCTION       *)
(* FUNCTION:  EXECUTE TUNEBASE FUNC   *)
(**************************************)
DEFINE_CALL 'TUNEBASE FUNCTION' (CDP_FUNC,X,Y)
LOCAL_VAR
X_VALUE                            (* VALUE OF X JOYSTICK *)
Y_VALUE                            (* VALUE OF Y JOYSTICK *)
{
  IF (CDP_FUNC = TB_JOYSTICK)
  {
    X_VALUE = X
    Y_VALUE = Y
    X_VALUE = (X_VALUE*626/255) + 4
    Y_VALUE = (255-Y_VALUE)*450/255
    SEND_STRING TUNEBASE,"'TBX71',
         ITOA(X_VALUE/100),ITOA((X_VALUE%100)/10),ITOA(X_VALUE%10),
         ITOA(Y_VALUE/100),ITOA((Y_VALUE%100)/10),ITOA(Y_VALUE%10),13"
  }
}

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

(* PANEL *)
CREATE_LEVEL TP,1,TP_JOYST_1X      (* LEVELS FOR OUR JOYSTICKS *)
CREATE_LEVEL TP,2,TP_JOYST_1Y

(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM

(* TUNEBASE *)
RELEASE[TP,125]                (* JOYSTICK *)
  CALL 'TUNEBASE FUNCTION' (TB_JOYSTICK,TP_JOYST_1X,TP_JOYST_1Y)

(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)
